#ifndef WARS_BUTTONCLASS
#define WARS_BUTTONCLASS

#include "StdHeaders.h"


//berwacht ein bestimmtes feld
class watcharea
{
protected:
	int positions[4];

public:
	//Konstruktor
	watcharea(int posX_L, int posX_R, int posY_T, int posY_B);

	//Wurde im Feld geklickt?
	int getstate();
};

//Button mit rechteck und text
class textbutton : public watcharea
{
private:
	int textX, textY;
	int textcolor, boxcolor;
	char *text;

public:
	//Konstruktor
	textbutton(int posX_L, int posX_R, int posY_T, int posY_B, int textx, int texty, char *label, int tColor, int bColor);

	//Zeichnen
	void draw();
};

//Button mit Bitmaps, wechselt das bitmap wenn mouseover ist
class button : public watcharea
{
protected:
	int size_x, size_y;
	BITMAP *picture, *mouseOver;
	bool no_mouseOver;

public:
	//Konstruktor
	button(int posX_L, int posX_R, int posY_T, int posY_B, char *mainpic, char *mouseover = NULL);

	//Destruktor
	~button();

	//Zeichne den Button
	void draw();
};

class maskedbutton : public button
{
public:
	//Konstruktor
	maskedbutton(int posX_L, int posX_R, int posY_T, int posY_B, char *mainpic, char *mouseover = NULL) : button(posX_L, posX_R, posY_T, posY_B, mainpic, mouseover) { };

	//Zeichne den Button
	void draw();
};

class checkBox : public watcharea
{
private:
	int size_x, size_y;
	int checked;
	BITMAP *cross;

public:
	//Konstruktor
	checkBox(int posX_L, int posX_R, int posY_T, int posY_B, BITMAP *cross, int initialValue);

	//Zeichne die Box
	void draw();

	//Wurde im Feld geklickt?
	int getstate();

	//checked auf value setzen
	void setChecked(int value);
};

#endif