////////////////////////////////////////////////////////
// This will convert any textfile to the map.war file //
////////////////////////////////////////////////////////

#include <fstream>
#include <iostream>
using namespace std;

int main(int argc, char *argv[])
{
	char temp;

	if(argc < 2)
	{
		cout << "No Argument!" << endl;
		cin >> temp;
		return 0;
	};
	char char2tile[26] = "sStTeEbBrRiIvV-GnlLNaAmuU";

	ifstream readfile(argv[1]);
	int length = strlen(argv[1]);

	char *newname = new char [length];
	for(int i = 0; i < length; ++i)
		newname[i] = argv[1][i];
	newname[length - 3] = 'w';
	newname[length - 2] = 'a';
	newname[length - 1] = 'r';
	ofstream writefile(newname, ios::binary);

	int sizes;
	readfile >> sizes;
	temp = sizes & 0xFF;
	writefile.write(&temp, 1);
	readfile >> sizes;
	temp = sizes & 0xFF;
	writefile.write(&temp, 1);
	while(!readfile.eof())
	{
		temp = readfile.get();
		if(temp < 33)
			continue;
		for(int i = 0; i < 25; ++i)
		{
			if(temp == char2tile[i])
			{
				char tempchar = (char) i;
				writefile.write(&tempchar, 1);
				break;
			};
		};
	};

	cout << "Finished" << endl;

	return 0;
};
