//////////////////////////////////////////////
// Wars Men zum kaufen einer neuen Einheit //
//////////////////////////////////////////////

#include "StdHeaders.h"

BITMAP *buyScreen = NULL;

int buyUnit(int *money, int player, BITMAP *margin, char allowedUnits, int *statistic)
{
	if(!buyScreen)
	{
		buyScreen = create_bitmap();
		blit(multiBG, buyScreen);
		BITMAP *buyBuffer = load_bitmap("buyUnit.tga");
		blit(buyBuffer, buyScreen, 166, 145, 485, 177);
		destroy_bitmap(buyBuffer);
	};
	int prices[7] = { 1000, 3000, 3000, 7000, 16000, 6000, 15000 };
	const int positions[7] = { 220, 270, 320, 370, 420, 470, 520 };
	const int height = 220;
	char *range[7] = { "1", "1", "1", "1", "1", "2-3", "3-5" },
		*damage[7] = { "Low", "Medium", "Low", "Medium", "High", "Medium", "High" };
	int retVal = 0;
	if(!allowedUnits & MILITIA)
		retVal = 1;
	const int WHITE = makecol(255, 255, 255),
		BROWN = makecol(156, 103, 0);
	maskedbutton
		buybutton(150, 300, 500, 540, "buy1.tga", "buy2.tga"),
		cancelbutton(450, 600, 500, 540, "cancel1.tga", "cancel2.tga");

	watcharea
		militia(220, 260, 220, 260),
		warrior(270, 310, 220, 260),
		scout(320, 360, 220, 260),
		cataphract(370, 410, 220, 260),
		knight(420, 460, 220, 260),
		catapult(470, 510, 220, 260),
		trebuchet(520, 560, 220, 260);

	//Tastenstati
	bool key_1 = 0, key_2 = 0, key_3 = 0, key_4 = 0, key_5 = 0, key_6 = 0, key_7 = 0;
	while(true)
	{
		if(timerCounter > 0)
		{
			mouseUpdate();
			--timerCounter;
			if(buybutton.getstate() || key[KEY_ENTER] && !key_enter)
			{
				key_enter = 1;
				if(*money >= prices[retVal])
				{
					*money -= prices[retVal];
					*statistic += prices[retVal];
					break;
				}
				else
					msgBox("Not enough money!");
			}
			else if(!key[KEY_ENTER])
				key_enter = 0;
			if(cancelbutton.getstate() || key[KEY_ESC] && !key_esc)
			{
				retVal = -1;
				key_esc = 1;
				break;
			}
			else if(!key[KEY_ESC])
				key_esc = 0;

			if(allowedUnits & MILITIA && (militia.getstate() || key[KEY_1] && !key_1))
			{
				retVal = 0;
				key_1 = 1;
			}
			else if(!key[KEY_1])
				key_1 = 0;
			if(allowedUnits & WARRIOR && (warrior.getstate() || key[KEY_2] && !key_2))
			{
				retVal = 1;
				key_2 = 1;
			}
			else if(!key[KEY_2])
				key_2 = 0;
			if(allowedUnits & SCOUT && (scout.getstate() || key[KEY_3] && !key_3))
			{
				retVal = 2;
				key_3 = 1;
			}
			else if(!key[KEY_3])
				key_3 = 0;
			if(allowedUnits & CATAPHRACT && (cataphract.getstate() || key[KEY_4] && !key_4))
			{
				retVal = 3;
				key_4 = 1;
			}
			else if(!key[KEY_4])
				key_4 = 0;
			if(allowedUnits & KNIGHT && (knight.getstate() || key[KEY_5] && !key_5))
			{
				retVal = 4;
				key_5 = 1;
			}
			else if(!key[KEY_5])
				key_5 = 0;
			if(allowedUnits & CATAPULT && (catapult.getstate() || key[KEY_6] && !key_6))
			{
				retVal = 5;
				key_6 = 1;
			}
			else if(!key[KEY_6])
				key_6 = 0;
			if(allowedUnits & TREBUCHET && (trebuchet.getstate() || key[KEY_7] && !key_7))
			{
				retVal = 6;
				key_7 = 1;
			}
			else if(!key[KEY_7])
				key_7 = 0;
		};

		blit(buyScreen, doubleBuffer);

		if(allowedUnits & MILITIA)
			masked_blit(sprites[player][0], doubleBuffer, 0, 0, positions[0], height, 40, 40);
		if(allowedUnits & WARRIOR)
			masked_blit(sprites[player][1], doubleBuffer, 0, 0, positions[1], height, 40, 40);
		if(allowedUnits & SCOUT)
			masked_blit(sprites[player][2], doubleBuffer, 0, 0, positions[2], height, 40, 40);
		if(allowedUnits & CATAPHRACT)
			masked_blit(sprites[player][3], doubleBuffer, 0, 0, positions[3], height, 40, 40);
		if(allowedUnits & KNIGHT)
			masked_blit(sprites[player][4], doubleBuffer, 0, 0, positions[4], height, 40, 40);
		if(allowedUnits & CATAPULT)
			masked_blit(sprites[player][5], doubleBuffer, 0, 0, positions[5], height, 40, 40);
		if(allowedUnits & TREBUCHET)
			masked_blit(sprites[player][6], doubleBuffer, 0, 0, positions[6], height, 40, 40);

		masked_blit(margin, doubleBuffer, 0, 0, positions[retVal], height, 40, 40);

		masked_blit(sprites[player][retVal], doubleBuffer, 0, 0, 380, 280, 40, 40);
		textprintf_centre(doubleBuffer, tahoma, 400, 325, BROWN, "%s", names[retVal]);
		textprintf_centre(doubleBuffer, tahoma, 400, 340, BROWN, "Costs: %i$", prices[retVal]);
		textprintf_centre(doubleBuffer, tahoma, 400, 355, BROWN, "Movepoints: %i", moveType[retVal]);
		textprintf_centre(doubleBuffer, tahoma, 400, 370, BROWN, "Range: %s", range[retVal]);
		textprintf_centre(doubleBuffer, tahoma, 400, 385, BROWN, "Damage: %s", damage[retVal]);

		textprintf(doubleBuffer, tahoma, 150, 480, BROWN, "You have %i$.", *money);

		cancelbutton.draw();
		buybutton.draw();
		mouseblit();
		show();
	};
	return retVal;
};
