//////////////////////////////////////////////////
// Spieleinstellungen knnen vorgenommen werden //
//////////////////////////////////////////////////

#include "StdHeaders.h"

BITMAP *mapSelectScreen = NULL;

void mapSelect(char *path)
{
	const int init = 0x7F,
		positions[7] = { 220, 270, 320, 370, 420, 470, 520 },
		height = 220,
		DBROWN = makecol( 99,  36, 16);
	int retVal = -11,
		flag = init,
		moneyPerBuilding = 1000,
		maxDays = 0;
	const char *pathes[14] =
	{
			"militia1.tga",
				"militia2.tga",
				"warrior1.tga",
				"warrior2.tga",
				"scout1.tga",
				"scout2.tga",
				"cataphract1.tga",
				"cataphract2.tga",
				"knight1.tga",
				"knight2.tga",
				"catapult1.tga",
				"catapult2.tga",
				"trebuchet1.tga",
				"trebuchet2.tga"
	};
	for(int i = 0; i < 2; ++i)
	{
		for(int a = 0; a < 7; ++a)
			if(!sprites[i][a])
				sprites[i][a] = load_bitmap(pathes[a*2 + i]);
	};
	if(!mapSelectScreen)
	{
		mapSelectScreen = create_bitmap();
		blit(multiBG, mapSelectScreen);

		BITMAP *mapSelectBuffer = load_bitmap("mapSelect.tga");
		blit(mapSelectBuffer, mapSelectScreen, 52, 162, 729, 295);
		destroy_bitmap(mapSelectBuffer);
	};
	BITMAP *cross = load_bitmap("cross.tga");
	checkBox cB_militia(235, 245, 270, 280, cross, 1),
		cB_warrior(285, 295, 270, 280, cross, 1),
		cB_scout(335, 345, 270, 280, cross, 1),
		cB_cataphract(385, 395, 270, 280, cross, 1),
		cB_knight(435, 445, 270, 280, cross, 1),
		cB_catapult(485, 495, 270, 280, cross, 1),
		cB_trebuchet(535, 545, 270, 280, cross, 1);

	maskedbutton
		okbutton(150, 300, 500, 540, "ok1.tga", "ok2.tga"),
		cancelbutton(450, 600, 500, 540, "cancel1.tga", "cancel2.tga");

	watcharea
		dollar1000( 70, 120, 380, 415),
		dollar1500(130, 180, 380, 415),
		dollar2000(190, 240, 380, 415),
		dollar3000(250, 300, 380, 415),
		dollar3500(310, 360, 380, 415),

		day0  (430, 480, 380, 415),
		day30 (490, 540, 380, 415),
		day50 (550, 600, 380, 415),
		day75 (610, 660, 380, 415),
		day100(670, 720, 380, 415),
		day150(730, 780, 380, 415);

	while(retVal < 0)
	{
////	//Logik//	 ////
		mouseUpdate();
		if(okbutton.getstate() || key[KEY_ENTER] && !key_enter)
		{
			retVal = 1;
			key_enter = 1;
		}
		else if(!key[KEY_ENTER])
			key_enter = 0;
		if(cancelbutton.getstate() || key[KEY_ESC] && !key_esc)
		{
			retVal = 0;
			key_esc = 1;
		}
		else if(!key[KEY_ESC])
			key_esc = 0;

		//Checkboxes prfen und verarbeiten
		if(cB_militia.getstate())
		{
			flag ^= MILITIA;
			if(!(flag & MILITIA))
			{
				flag |= WARRIOR;
				cB_warrior.setChecked(1);
			};
		};
		if(cB_warrior.getstate())
		{
			flag ^= WARRIOR;
			if(!(flag & WARRIOR))
			{
				flag |= MILITIA;
				cB_militia.setChecked(1);
			};
		};
		if(cB_scout.getstate())
			flag ^= SCOUT;
		if(cB_cataphract.getstate())
			flag ^= CATAPHRACT;
		if(cB_knight.getstate())
			flag ^= KNIGHT;
		if(cB_catapult.getstate())
			flag ^= CATAPULT;
		if(cB_trebuchet.getstate())
			flag ^= TREBUCHET;

		if(dollar1000.getstate())
			moneyPerBuilding = 1000;
		if(dollar1500.getstate())
			moneyPerBuilding = 1500;
		if(dollar2000.getstate())
			moneyPerBuilding = 2000;
		if(dollar3000.getstate())
			moneyPerBuilding = 3000;
		if(dollar3500.getstate())
			moneyPerBuilding = 3500;
		if(day0.getstate())
			maxDays = 0;
		if(day30.getstate())
			maxDays = 30;
		if(day50.getstate())
			maxDays = 50;
		if(day75.getstate())
			maxDays = 75;
		if(day100.getstate())
			maxDays = 100;
		if(day150.getstate())
			maxDays = 150;

////	//Grafik//	  ////
		blit(mapSelectScreen, doubleBuffer);

		//Show flag for debugging
//		textprintf_centre(doubleBuffer, tahoma, 400, 325, makecol(255, 255, 255), "%i", flag);

		//Bilder der Einheiten anzeigen
		masked_blit(sprites[0][0], doubleBuffer, 0, 0, positions[0], height, 40, 40);
		masked_blit(sprites[0][1], doubleBuffer, 0, 0, positions[1], height, 40, 40);
		masked_blit(sprites[0][2], doubleBuffer, 0, 0, positions[2], height, 40, 40);
		masked_blit(sprites[0][3], doubleBuffer, 0, 0, positions[3], height, 40, 40);
		masked_blit(sprites[0][4], doubleBuffer, 0, 0, positions[4], height, 40, 40);
		masked_blit(sprites[0][5], doubleBuffer, 0, 0, positions[5], height, 40, 40);
		masked_blit(sprites[0][6], doubleBuffer, 0, 0, positions[6], height, 40, 40);
		//Checkbox Kreuze anzeigen
		cB_militia.draw();
		cB_warrior.draw();
		cB_scout.draw();
		cB_cataphract.draw();
		cB_knight.draw();
		cB_catapult.draw();
		cB_trebuchet.draw();
		//Buttons anzeigen
		cancelbutton.draw();
		okbutton.draw();
		//Texte
		textprintf_centre(doubleBuffer, tahoma, 215, 427, DBROWN, "%i$", moneyPerBuilding);
		if(maxDays)
			textprintf_centre(doubleBuffer, tahoma, 605, 427, DBROWN, "%i", maxDays);
		else
			textout_centre(doubleBuffer, tahoma, "Off", 605, 427, DBROWN);
		//Maus anzeigen
		mouseblit();

		show();
		reset();
	};
	destroy_bitmap(cross);
	mouseUpdate();
	if(retVal)
		game(path, moneyPerBuilding, flag, maxDays);
};
