///////////////////////////////////////////////////
// Wars: Diese Datei enthlt einige Menroutinen //
///////////////////////////////////////////////////

#include "StdHeaders.h"

BITMAP *menuBackground = NULL, *bgbox = NULL;

int menu()
{
	if(!menuBackground)
	{
		menuBackground = create_bitmap();
		blit(multiBG, menuBackground);
		BITMAP *menuBuffer = load_bitmap("menu.tga");
		blit(menuBuffer, menuBackground, 249, 8, 302, 544);
		destroy_bitmap(menuBuffer);
	};

	//Felder die es zu berwachen gilt
	maskedbutton
		newgamebutton(250, 550, 50, 100, "play.tga"),
		helpbutton(250, 550, 200, 250, "helpmenu.tga"),
		creditsbutton(250, 550, 350, 400, "credits.tga"),
		exitbutton(250, 550, 500, 550, "exit.tga");

	int retVal;

	while(TRUE)
	{
		if(timerCounter > 1)
		{
			mouseUpdate();
			--timerCounter;
		};
		blit(menuBackground, doubleBuffer);
		newgamebutton.draw();
		helpbutton.draw();
		creditsbutton.draw();
		exitbutton.draw();
		mouseblit();
		show();
		if(released)
		{
			if(newgamebutton.getstate())
			{
				retVal = 1;
				break;
			}
			if(helpbutton.getstate())
			{
				retVal = 2;
				break;
			}
			if(creditsbutton.getstate())
			{
				retVal = 3;
				break;
			}
			if(exitbutton.getstate())
			{
				retVal = 0;
				break;
			};
		};
	};

	released = 0;
	return retVal;
};

//Liefert das Ergebnis einer Abfrage zurck
int yesno(char *question)
{
	//Bitmaps fr die Abfrage laden
	if(!bgbox)
		bgbox = load_bitmap("box.tga");

	//Buttons
	maskedbutton green(245, 395, 339, 379, "yes1.tga", "yes2.tga"),
		red(405, 555, 339, 379, "no1.tga", "no2.tga");

	int retVal;
	//Mainloop
	while(TRUE)
	{
		//TimerCounter niedrig halten
		if(timerCounter > 1)
		{
			mouseUpdate();
			--timerCounter;
		};

		//Hintergrundbox zeichnen
		blit(bgbox, doubleBuffer, 235, 190, 330, 220);
		//Die Felder zeichnen
		green.draw();
		red.draw();

		//Texte auf die Felder blitten
		textout_centre(doubleBuffer, tahoma, question,
			400, 250, makecol(156, 103, 0));
		//Maus auf den Buffer und dann Buffer auf den Schirm blitten
		mouseblit();
		show();

		//Checken ob ein Feld bettigt wurde
		if(green.getstate() || key[KEY_ENTER] && !key_enter)
		{
			key_enter = 1;
			retVal = 1;
			break;
		}
		else if(!key[KEY_ENTER])
			key_enter = 0;
		if(red.getstate() || key[KEY_ESC] && !key_esc)
		{
			key_esc = 1;
			retVal = 0;
			break;
		}
		else if(!key[KEY_ESC])
			key_esc = 0;
	};
	//Mausstatus aktualisieren
	released = 0;
	return retVal;
};

//Zeigt eine Nachrichtenbox an
void msgBox(char *infotext)
{
	//Hintergrundbox
	if(!bgbox)
		bgbox = load_bitmap("box.tga");

	//Buttons
	maskedbutton ok(318,468, 330, 370, "ok1.tga", "ok2.tga");

	//Mainloop
	while(TRUE)
	{
		if(timerCounter > 1)
		{
			mouseUpdate();
			--timerCounter;
		};
		//Box anzeigen
		blit(bgbox, doubleBuffer, 235, 190, 330, 220);

		//Button zeichnen
		ok.draw();

		//Text auf das Feld blitten
		textout_centre(doubleBuffer, tahoma, infotext,
			400, 250, makecol(156, 103, 0));
		//Maus auf Buffer und Buffer auf Screen blitten
		mouseblit();
		show();
		//Wenn die Maus ber dem Feld losgelassen wird, loop beenden
		if(ok.getstate() || key[KEY_ENTER] && !key_enter || key[KEY_ESC] && !key_esc)
		{
			key_enter = 1;
			key_esc = 1;
			break;
		}
		else
		{
			if(!key[KEY_ENTER])
				key_enter = 0;
			if(!key[KEY_ESC])
				key_esc = 0;
		};
	};
	//Maus aktualisieren
	released = 0;
};
