////////////////////////////
// Wars Mausroutinendatei //
////////////////////////////

#include "StdHeaders.h"

//Globalen
BITMAP *pointer = NULL;
SAMPLE *click = NULL;
int mButton = 0, released = 0;

//Ld alle Mausressourcen und installiert die Maustreiber
void mouse_init()
{
	if(install_mouse() < 0)
		fatalError("Error006: No mousedriver found");

	click = load_wav("click.wav");
	if(!click)
		Error004("click.wav");

	//Mauszeiger laden
	pointer = load_bitmap("cursor.tga");
};

void mouse_uninstall()
{
	destroy_bitmap(pointer);
	destroy_sample(click);
};

//Checkt, ob sich der Mauszeiger innerhalb der angegebenen Koordinaten befindet
bool area(int x_l, int x_r, int y_t, int y_b)
{
	if(mouse_y >= y_t && mouse_y <= y_b && mouse_x >= x_l && mouse_x <= x_r)
		return 1;
	else
		return 0;
};

//Mauszeiger anzeigen
void mouseblit()
{
	draw_sprite(doubleBuffer, pointer, mouse_x, mouse_y);
};

//Aktualisiert den Mausstatus
void mouseUpdate()
{
	if(mouse_b & 0x1)
	{
		mButton = 1;
	}
	else
	{
		if(released)
			released = 0;
		if(mButton)
		{
			released = 1;
			mButton = 0;
		};
	};
};

void clickSound()
{
	play_sample(click, 255, 128, 1000, 0);
};
